/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// ANALYSED BY DANY:
// FEBRUARY 2007:
// CARIBBEAN BY ENSEMBLE:
// FEBRUARY 2003:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
/*----------------------------------------------------------------------------------------------------------------*/
        if (rmAllocateSubCivs(5) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee"); 

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");

		subCiv4=rmGetCivID("Cherokee");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Cherokee");
	}	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// **************************************** DEFINE THE SIZE OF THE MAP: ***************************************** //	
/*================================================================================================================*/	
        int playerTiles=30000;
	    
		if (cNumberNonGaiaPlayers >4)
		playerTiles = 20000;
	    if (cNumberNonGaiaPlayers >7)
		playerTiles = 15000;			
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ************************************ DEFINE THE PARAMETERS OF THE MAP: *************************************** //
/*================================================================================================================*/
        // SET THE SEA LEVEL:
        rmSetSeaLevel(2.0);
        
		// SET THE SEA TYPE:
		//rmSetSeaType("caribbean coast");
		  rmSetSeaType("new england coast");
		
 	    
		// SET THE BASE TERRAIN:
		//rmSetBaseTerrainMix("caribbean grass");
		  rmSetBaseTerrainMix("newengland_grass");
	    
		// SET THE MAP TYPE:
		//rmSetMapType("caribbean");
		  rmSetMapType("newEngland");
	    rmSetMapType("grass");
	    rmSetMapType("water");
        
		// SET THE LIGHTING:
		//rmSetLightingSet("caribbean");
		  rmSetLightingSet("new england");

        // SET THE INITIALIZATION OF THE MAP:
        rmTerrainInitialize("water");
		
		// CHOOSES THE MERCS:
		chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES. THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int classPlayer=rmDefineClass("player");
        int classIsland=rmDefineClass("island");
        int classBonusIsland=rmDefineClass("bonusIsland");
        int classTeamIsland=rmDefineClass("teamIsland");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classSocket"); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // CREATE A EDGE OF MAP CONSTRAINT:
        //int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));
        int playerEdgeConstraint=rmCreatePieConstraint("continent avoids edge",  0.5, 0.5, 0, rmGetMapXSize()-10, 0, 0, 0);
	     
        
		// PLAYER AREA CONSTRAINT:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 25.0);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("long stay away from players", classPlayer, 60.0);
        int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 12.0);
	    int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", 15.0);
		
		// Cardinal Directions
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.55, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(0), rmDegreesToRadians(90));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.45, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(180), rmDegreesToRadians(270));
        //int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.45, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        //int Westward=rmCreatePieConstraint("westMapConstraint", 0.55, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        
		// WATER AVOIDANCE:
		int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
        int nearWaterDock = rmCreateTerrainDistanceConstraint("near water for Dock", "Water", true, 0.0);
	    int avoidLand = rmCreateTerrainDistanceConstraint("ship avoid land", "land", true, 15.0);


        // BONUS AREA CONSTRAINT:
        //int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 55.0);
		int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 40.0);
        // int bonusIslandConstraint=rmCreateClassDistanceConstraint("bonus islands avoid islands", classIsland, 30.0);
        int avoidBonusIslands=rmCreateClassDistanceConstraint("stuff avoids bonus islands", classBonusIsland, 30.0);
        int avoidTeamIslands=rmCreateClassDistanceConstraint("stuff avoids team islands", classTeamIsland, 30.0);
 
	    // SEAFOOD AVOIDANCE:
	    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "FishCod", 12.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 70.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);
        
		// FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
        
		// RESOURCE AVOIDANCE:
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
        
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "mine", 4.0);
		int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "mine", 30.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids fruits", "berrybush", 4.0);
        int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 8.0);
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoids trees", "TreeNewEngland", 4.0);
        int treesAvoidTrees=rmCreateTypeDistanceConstraint("trees avoids trees", "TreeNewEngland", 8.0);
		
		// DEERS AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 4.0);
        int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 8.0);
		
		int avoidWood=rmCreateTypeDistanceConstraint("stuff avoids wood", "TreeAmazon", 4.0);
		int woodAvoidWood=rmCreateTypeDistanceConstraint("wood avoids wood", "TreeAmazon", 8.0);
        
		// TREASURES AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "abstractNugget", 6.0);
		int nuggetAvoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 8.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 2.0);

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);

	    // CONSTRAINT TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 8.0);
		int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 12.0);
	    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);

        // FLAG AVOIDANCE:
        int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
        int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 25);
        int flagEdgeConstraint = rmCreatePieConstraint("flags away from edge of map", 0.5, 0.5, rmGetMapXSize()-200, rmGetMapXSize()-100, 0, 0, 0);
        rmAddClosestPointConstraint(avoidWater8);
        
		// TRADEROUTE AND SOCKET AVOIDANCE:
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
        int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 25.0);
        
		// DECORATIONS AVOIDANCE:
		int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
/*================================================================================================================*/
// **************************************** DONE DEFINING THE OBJECTS: ****************************************** //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// *************************************** DEFINE THE NORTHERN ISLAND 1: **************************************** //
/*================================================================================================================*/
        int bigIslandID=rmCreateArea("big lone island");
        rmSetAreaSize(bigIslandID, 0.17, 0.17);
        rmSetAreaMinBlobs(bigIslandID, 10);
        rmSetAreaMaxBlobs(bigIslandID, 15);
        rmSetAreaMinBlobDistance(bigIslandID, 8.0);
        rmSetAreaMaxBlobDistance(bigIslandID, 10.0);
        rmSetAreaCoherence(bigIslandID, 0.55);
        rmSetAreaBaseHeight(bigIslandID, 2.0);
        rmSetAreaSmoothDistance(bigIslandID, 20);
		//rmSetAreaMix(bigIslandID, "caribbean grass");
		  rmSetAreaMix(bigIslandID, "newengland_grass");
        rmAddAreaToClass(bigIslandID, classIsland);
        rmAddAreaConstraint(bigIslandID, islandConstraint);
        rmSetAreaObeyWorldCircleConstraint(bigIslandID, false);
        rmSetAreaElevationType(bigIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(bigIslandID, 4.0);
        rmSetAreaElevationMinFrequency(bigIslandID, 0.09);
        rmSetAreaElevationOctaves(bigIslandID, 3);
        rmSetAreaElevationPersistence(bigIslandID, 0.2);
		rmSetAreaElevationNoiseBias(bigIslandID, 1);
        rmSetAreaWarnFailure(bigIslandID, false);
		rmSetAreaLocation(bigIslandID, 1, 1);
		rmBuildArea(bigIslandID); 
/*================================================================================================================*/
// ************************************** DEFINE THE SOUTHERN ISLAND 2: ***************************************** //
/*================================================================================================================*/
		int bigIsland2ID=rmCreateArea("big lone island 2");
        rmSetAreaSize(bigIsland2ID, 0.17, 0.17);
        rmSetAreaMinBlobs(bigIsland2ID, 10);
        rmSetAreaMaxBlobs(bigIsland2ID, 15);
        rmSetAreaMinBlobDistance(bigIsland2ID, 8.0);
        rmSetAreaMaxBlobDistance(bigIsland2ID, 10.0);
        rmSetAreaCoherence(bigIsland2ID, 0.55);
        rmSetAreaBaseHeight(bigIsland2ID, 2.0);
        rmSetAreaSmoothDistance(bigIsland2ID, 20);
		//rmSetAreaMix(bigIsland2ID, "caribbean grass");
		rmSetAreaMix(bigIsland2ID, "newengland_grass");
        rmAddAreaToClass(bigIsland2ID, classIsland);
        rmAddAreaConstraint(bigIsland2ID, islandConstraint);
        rmSetAreaObeyWorldCircleConstraint(bigIsland2ID, false);
        rmSetAreaElevationType(bigIsland2ID, cElevTurbulence);
        rmSetAreaElevationVariation(bigIsland2ID, 4.0);
        rmSetAreaElevationMinFrequency(bigIsland2ID, 0.09);
        rmSetAreaElevationOctaves(bigIsland2ID, 3);
        rmSetAreaElevationPersistence(bigIsland2ID, 0.2);
		rmSetAreaElevationNoiseBias(bigIsland2ID, 1);
        rmSetAreaWarnFailure(bigIsland2ID, false);
		rmSetAreaLocation(bigIsland2ID, 0, 0);
		rmBuildArea(bigIsland2ID);
/*================================================================================================================*/		
// ************************************** DEFINE THE SOUTHERN ISLAND 3: ***************************************** //
/*================================================================================================================*/
		int bigIsland3ID=rmCreateArea("big lone island 3");
        //rmSetAreaSize(bigIsland3ID, 0.14, 0.14);
		rmSetAreaSize(bigIsland3ID, 0.0455, 0.0355);
        rmSetAreaMinBlobs(bigIsland3ID, 1);
        rmSetAreaMaxBlobs(bigIsland3ID, 1);
        rmSetAreaMinBlobDistance(bigIsland3ID, 1.0);
        rmSetAreaMaxBlobDistance(bigIsland3ID, 1.0);
        rmSetAreaCoherence(bigIsland3ID, 0.55);
        rmSetAreaBaseHeight(bigIsland3ID, 2.0);
        rmSetAreaSmoothDistance(bigIsland3ID, 20);
		//rmSetAreaMix(bigIsland3ID, "caribbean grass");
		rmSetAreaMix(bigIsland3ID, "newengland_grass");
        rmAddAreaToClass(bigIsland3ID, classIsland);
        rmAddAreaConstraint(bigIsland3ID, islandConstraint);
        rmSetAreaObeyWorldCircleConstraint(bigIsland3ID, false);
        rmSetAreaElevationType(bigIsland3ID, cElevTurbulence);
        rmSetAreaElevationVariation(bigIsland3ID, 4.0);
        rmSetAreaElevationMinFrequency(bigIsland3ID, 0.09);
        rmSetAreaElevationOctaves(bigIsland3ID, 3);
        rmSetAreaElevationPersistence(bigIsland3ID, 0.2);
		rmSetAreaElevationNoiseBias(bigIsland3ID, 1);
        rmSetAreaWarnFailure(bigIsland3ID, false);
		rmSetAreaLocation(bigIsland3ID, 0.5, 0.5);
		rmBuildArea(bigIsland3ID);	
/*================================================================================================================*/		
// ************************************** DEFINE THE SOUTHERN ISLAND 4: ***************************************** //
/*================================================================================================================*/
		int bigIsland4ID=rmCreateArea("big lone island 4");
        //rmSetAreaSize(bigIsland4ID, 0.14, 0.14);
		// rmSetAreaSize(bigIsland4ID, 0.040, 0.040);
		   rmSetAreaSize(bigIsland4ID, 0.065, 0.065);
        /*rmSetAreaMinBlobs(bigIsland4ID, 10);
        rmSetAreaMaxBlobs(bigIsland4ID, 15);
        rmSetAreaMinBlobDistance(bigIsland4ID, 8.0);
        rmSetAreaMaxBlobDistance(bigIsland4ID, 10.0);*/
        rmSetAreaCoherence(bigIsland4ID, 0.55);
        rmSetAreaBaseHeight(bigIsland4ID, 2.0);
        rmSetAreaSmoothDistance(bigIsland4ID, 20);
		//rmSetAreaMix(bigIsland4ID, "caribbean grass");
		rmSetAreaMix(bigIsland4ID, "newengland_grass");
        rmAddAreaToClass(bigIsland4ID, classIsland);
        rmAddAreaConstraint(bigIsland4ID, islandConstraint);
        rmSetAreaObeyWorldCircleConstraint(bigIsland4ID, false);
        rmSetAreaElevationType(bigIsland4ID, cElevTurbulence);
        rmSetAreaElevationVariation(bigIsland4ID, 4.0);
        rmSetAreaElevationMinFrequency(bigIsland4ID, 0.09);
        rmSetAreaElevationOctaves(bigIsland4ID, 3);
        rmSetAreaElevationPersistence(bigIsland4ID, 0.2);
		rmSetAreaElevationNoiseBias(bigIsland4ID, 1);
        rmSetAreaWarnFailure(bigIsland4ID, false);
		// rmSetAreaLocation(bigIsland4ID, 0.3, 0.7);
		   rmSetAreaLocation(bigIsland4ID, 0.2, 0.775);
		rmBuildArea(bigIsland4ID);
/*================================================================================================================*/		
// ************************************** DEFINE THE SOUTHERN ISLAND 5: ***************************************** //
/*================================================================================================================*/
		int bigIsland5ID=rmCreateArea("big lone island 5");
        //rmSetAreaSize(bigIsland5ID, 0.14, 0.14);
		// rmSetAreaSize(bigIsland5ID, 0.040, 0.040);
		   rmSetAreaSize(bigIsland5ID, 0.065, 0.065);
       /* rmSetAreaMinBlobs(bigIsland5ID, 10);
        rmSetAreaMaxBlobs(bigIsland5ID, 15);
        rmSetAreaMinBlobDistance(bigIsland5ID, 8.0);
        rmSetAreaMaxBlobDistance(bigIsland5ID, 10.0);*/
        rmSetAreaCoherence(bigIsland5ID, 0.55);
        rmSetAreaBaseHeight(bigIsland5ID, 2.0);
        rmSetAreaSmoothDistance(bigIsland5ID, 20);
		//rmSetAreaMix(bigIsland5ID, "caribbean grass");
		rmSetAreaMix(bigIsland5ID, "newengland_grass");
        rmAddAreaToClass(bigIsland5ID, classIsland);
        rmAddAreaConstraint(bigIsland5ID, islandConstraint);
        rmSetAreaObeyWorldCircleConstraint(bigIsland5ID, false);
        rmSetAreaElevationType(bigIsland5ID, cElevTurbulence);
        rmSetAreaElevationVariation(bigIsland5ID, 4.0);
        rmSetAreaElevationMinFrequency(bigIsland5ID, 0.09);
        rmSetAreaElevationOctaves(bigIsland5ID, 3);
        rmSetAreaElevationPersistence(bigIsland5ID, 0.2);
		rmSetAreaElevationNoiseBias(bigIsland5ID, 1);
        rmSetAreaWarnFailure(bigIsland5ID, false);
		rmSetAreaLocation(bigIsland5ID, 0.775, 0.2);
		rmBuildArea(bigIsland5ID);		
/*================================================================================================================*/
// ********************************* SET UP THE PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/
        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.765,0.765);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.225,0.225);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
      // float playerFraction=rmAreaTilesToFraction(int tiles);
	     float playerFraction=rmAreaTilesToFraction(100);
      
	  for(i=1; <cNumberPlayers)
   {
      // CREATE THE AREA:
      // int areaID=rmCreateArea(string name, int parentAreaID);
	     int id=rmCreateArea("Player"+i);
      // ASSIGN TO THE PLAYER:
      // rmSetPlayerArea(int playerID, int areaID);
	     rmSetPlayerArea(i, id);
      // SET THE SIZE:
      // rmSetAreaSize(int areaID, float minFraction, float maxFraction);
	     rmSetAreaSize(id, playerFraction, playerFraction);
      // ADD AREA TO CLASS:
	  // bool rmAddAreaToClass(int areaID, int classID);
	          rmAddAreaToClass(id, classPlayer);
      // SET AREA MIN BLOBS:
	  // rmSetAreaMinBlobs(int areaID, float dist);
	     rmSetAreaMinBlobs(id, 1);
      // SET AREA MAX BLOBS:
	  // rmSetAreaMaxBlobs(int areaID, float dist);
	     rmSetAreaMaxBlobs(id, 1);
      // ADD AREA CONSTRAINT:
	  // bool rmAddAreaConstraint(int areaID, int constraintID);
	          rmAddAreaConstraint(id, playerConstraint); 
              rmAddAreaConstraint(id, playerEdgeConstraint); 
      // SET AREA LOC PLAYER:
	  // rmSetAreaLocPlayer(int areaID, int playerID);
	     rmSetAreaLocPlayer(id, i);
	  // SET AREA WARN FAILURE:
	  // rmSetAreaWarnFailure(int areaID, bool warn);
	     rmSetAreaWarnFailure(id, false);
   }	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// *********************************** CLEAR OUT CONSTRAINTS FOR GOOD MEASURE: ********************************** //
/*================================================================================================================*/
   rmClearClosestPointConstraints(); 
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE TRADEROUTE AND THE SOCKETS: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE LONENY CARIBS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.51, 0.51);
	} 

	if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.7, 0.90);
	} 

	if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.375, 0.10);
	}

	if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.8, 0.175);
	}
	
	if (subCiv4 == rmGetCivID("cherokee"))
	{  
		int cherokee5VillageID = -1;
		cherokee5VillageID = rmCreateGrouping("cherokee village 5", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee5VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee5VillageID, 0.0);
		rmAddGroupingToClass(cherokee5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee5VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee5VillageID, 0, 0.18, 0.825);
	}  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ********************************* DEFINE THE TCID AND THE STARTING UNITS : *********************************** //	
/*================================================================================================================*/
	    int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
	    //rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	    rmAddObjectDefConstraint(TCID, avoidTC);
	
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 18.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);
/*================================================================================================================*/
// *************************************** DEFINE THE STARTING RESOURCES: *************************************** //
/*================================================================================================================*/
	    int playerBerries1ID = rmCreateObjectDef("player berries 1");
	    rmAddObjectDefItem(playerBerries1ID, "berrybush", rmRandInt(3,5), 6.0);
	    rmAddObjectDefConstraint(playerBerries1ID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerBerries1ID, 15.0);
	    rmSetObjectDefMaxDistance(playerBerries1ID, 20.0);
	    rmAddObjectDefConstraint(playerBerries1ID, avoidAll);
        rmAddObjectDefConstraint(playerBerries1ID, avoidImpassableLand);
		
		int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 10.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 30.0);
	    rmAddObjectDefConstraint(playerSilverID, avoidAll);
        rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);

	    int playerDeerID=rmCreateObjectDef("player deer");
        rmAddObjectDefItem(playerDeerID, "deer", rmRandInt(10,15), 10.0);
        rmSetObjectDefMinDistance(playerDeerID, 12);
        rmSetObjectDefMaxDistance(playerDeerID, 50);
	    rmAddObjectDefConstraint(playerDeerID, avoidAll);
        rmAddObjectDefConstraint(playerDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerDeerID, true);
/*================================================================================================================*/
// ****************************** PLACE THE STARTING UNITS AND STARTING RESOURCES: ****************************** //
/*================================================================================================================*/
	int colonyShipID = 0;
   
	for(i=1; <cNumberPlayers)
   {
    rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
	

	colonyShipID=rmCreateObjectDef("colony ship "+i);
	rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 1.0);
	if ( rmGetNomadStart())
	{
		if(rmGetPlayerCiv(i) == rmGetCivID("Ottomans"))
			rmAddObjectDefItem(colonyShipID, "Galley", 1, 10.0);
		else
			rmAddObjectDefItem(colonyShipID, "caravel", 1, 10.0);
	}
	rmAddClosestPointConstraint(flagEdgeConstraint);
	rmAddClosestPointConstraint(flagVsFlag);
	rmAddClosestPointConstraint(flagLand);
	vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	rmPlaceObjectDefAtLoc(colonyShipID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	
	rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	//rmPlaceObjectDefAtLoc(playerBerries1ID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	//rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	//rmPlaceObjectDefAtLoc(playerDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
   }
   
   rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// **************************************** STUFFS ON THE LEFT ISLAND: ****************************************** //
/*================================================================================================================*/
        int silver2ID = rmCreateObjectDef("random silver 2");
	    rmAddObjectDefItem(silver2ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver2ID, 0.0);
	    rmSetObjectDefMaxDistance(silver2ID, 0.0);
	    rmAddObjectDefConstraint(silver2ID, avoidCoin);
		rmAddObjectDefConstraint(silver2ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.2, 0.86); // ok
		
		int silver5ID = rmCreateObjectDef("random silver 5");
	    rmAddObjectDefItem(silver5ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver5ID, 0.0);
	    rmSetObjectDefMaxDistance(silver5ID, 0.0);
	    rmAddObjectDefConstraint(silver5ID, avoidCoin);
		rmAddObjectDefConstraint(silver5ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.19, 0.69); 
		
		int nugget3= rmCreateObjectDef("nugget easy 3"); 
	    rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nugget3, 0.0);
	    rmSetObjectDefMaxDistance(nugget3, 0.0);
	    rmAddObjectDefConstraint(nugget3, avoidNugget);
  	    rmAddObjectDefConstraint(nugget3, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.13, 0.8); // ok
		
		int nugget6= rmCreateObjectDef("nugget easy 6"); 
	    rmAddObjectDefItem(nugget6, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget6, 0.0);
	    rmSetObjectDefMaxDistance(nugget6, 0.0);
	    rmAddObjectDefConstraint(nugget6, avoidNugget);
  	    rmAddObjectDefConstraint(nugget6, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget6, 0, 0.2, 0.78); // ok

		int nugget7= rmCreateObjectDef("nugget easy 7"); 
	    rmAddObjectDefItem(nugget7, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget7, 0.0);
	    rmSetObjectDefMaxDistance(nugget7, 0.0);
	    rmAddObjectDefConstraint(nugget7, avoidNugget);
  	    rmAddObjectDefConstraint(nugget7, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget7, 0, 0.16, 0.70); 
		
		int nugget8= rmCreateObjectDef("nugget easy 8"); 
	    rmAddObjectDefItem(nugget8, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget8, 0.0);
	    rmSetObjectDefMaxDistance(nugget8, 0.0);
	    rmAddObjectDefConstraint(nugget8, avoidNugget);
  	    rmAddObjectDefConstraint(nugget8, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget8, 0, 0.25, 0.83); 
		
		int Berries2ID = rmCreateObjectDef("random Berries 2");
	    rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,5), 4.0);
	    rmSetObjectDefMinDistance(Berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries2ID, 0.0);
	    rmAddObjectDefConstraint(Berries2ID, avoidFruits);
		rmAddObjectDefConstraint(Berries2ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.226, 0.7);
		
		int Berries7ID = rmCreateObjectDef("random Berries 7");
	    rmAddObjectDefItem(Berries7ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries7ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries7ID, 0.0);
	    rmAddObjectDefConstraint(Berries7ID, avoidFruits);
		rmAddObjectDefConstraint(Berries7ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries7ID, 0, 0.23, 0.810);
		
		int Berries8ID = rmCreateObjectDef("random Berries 8");
	    rmAddObjectDefItem(Berries8ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries8ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries8ID, 0.0);
	    rmAddObjectDefConstraint(Berries8ID, avoidFruits);
		rmAddObjectDefConstraint(Berries8ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries8ID, 0, 0.125, 0.70);
		
		int Tree1ID = rmCreateObjectDef("random Trees 1");
	    rmAddObjectDefItem(Tree1ID, "TreeNewEngland", rmRandInt(10,15), 10.0);
		rmSetObjectDefMinDistance(Tree1ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree1ID, 0.0);
	    rmAddObjectDefConstraint(Tree1ID, avoidTrees);
		rmAddObjectDefConstraint(Tree1ID, treesAvoidTrees);
		rmPlaceObjectDefAtLoc(Tree1ID, 0, 0.26, 0.77);
		
		int Tree4ID = rmCreateObjectDef("random Trees 4");
	    rmAddObjectDefItem(Tree4ID, "TreeNewEngland", rmRandInt(10,15), 6.0);
		rmSetObjectDefMinDistance(Tree4ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree4ID, 0.0);
	    rmAddObjectDefConstraint(Tree4ID, avoidTrees);
		rmAddObjectDefConstraint(Tree4ID, treesAvoidTrees);
		rmPlaceObjectDefAtLoc(Tree4ID, 0, 0.11, 0.74);
		
		int Tree6ID = rmCreateObjectDef("random Trees 6");
	    rmAddObjectDefItem(Tree6ID, "TreeNewEngland", rmRandInt(8,12), 6.0);
		rmSetObjectDefMinDistance(Tree6ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree6ID, 0.0);
	    rmAddObjectDefConstraint(Tree6ID, avoidTrees);
		rmAddObjectDefConstraint(Tree6ID, treesAvoidTrees);
		rmPlaceObjectDefAtLoc(Tree6ID, 0, 0.18, 0.735);
		
		rmClearClosestPointConstraints();
/*================================================================================================================*/  	    
// ************************************** STUFFS ON THE MIDDLE ISLAND: ****************************************** //
/*================================================================================================================*/		
		int silver3ID = rmCreateObjectDef("random silver 3");
	    rmAddObjectDefItem(silver3ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver3ID, 0.0);
	    rmSetObjectDefMaxDistance(silver3ID, 0.0);
	    rmAddObjectDefConstraint(silver3ID, avoidCoin);
		rmAddObjectDefConstraint(silver3ID, coinAvoidCoin);
		rmAddObjectDefConstraint(silver3ID, avoidNatives);
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.5, 0.548);
		
		int silver6ID = rmCreateObjectDef("random silver 6");
	    rmAddObjectDefItem(silver6ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver6ID, 0.0);
	    rmSetObjectDefMaxDistance(silver6ID, 0.0);
	    rmAddObjectDefConstraint(silver6ID, avoidCoin);
		rmAddObjectDefConstraint(silver6ID, coinAvoidCoin);
		rmAddObjectDefConstraint(silver6ID, avoidNatives);
		rmPlaceObjectDefAtLoc(silver6ID, 0, 0.54, 0.48); 
		
		int nugget5= rmCreateObjectDef("nugget easy 5"); 
	    rmAddObjectDefItem(nugget5, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nugget5, 0.0);
	    rmSetObjectDefMaxDistance(nugget5, 0.0);
	    rmAddObjectDefConstraint(nugget5, avoidNugget);
  	    rmAddObjectDefConstraint(nugget5, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget5, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget5, 0, 0.45, 0.48);
		
		int nugget14= rmCreateObjectDef("nugget easy 14"); 
	    rmAddObjectDefItem(nugget14, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget14, 0.0);
	    rmSetObjectDefMaxDistance(nugget14, 0.0);
	    rmAddObjectDefConstraint(nugget14, avoidNugget);
  	    rmAddObjectDefConstraint(nugget14, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget14, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget14, 0, 0.4175, 0.495); 
		
		int nugget15= rmCreateObjectDef("nugget easy 15"); 
	    rmAddObjectDefItem(nugget15, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget15, 0.0);
	    rmSetObjectDefMaxDistance(nugget15, 0.0);
	    rmAddObjectDefConstraint(nugget15, avoidNugget);
  	    rmAddObjectDefConstraint(nugget15, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget15, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget15, 0, 0.555, 0.5); 
		
		int nugget16= rmCreateObjectDef("nugget easy 16"); 
	    rmAddObjectDefItem(nugget16, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget16, 0.0);
	    rmSetObjectDefMaxDistance(nugget16, 0.0);
	    rmAddObjectDefConstraint(nugget16, avoidNugget);
  	    rmAddObjectDefConstraint(nugget16, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget16, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget16, 0, 0.55, 0.45); 
		
		int Berries4ID = rmCreateObjectDef("random Berries 4");
	    rmAddObjectDefItem(Berries4ID, "berrybush", rmRandInt(3,5), 4.0);
	    rmSetObjectDefMinDistance(Berries4ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries4ID, 0.0);
	    rmAddObjectDefConstraint(Berries4ID, avoidFruits);
		rmAddObjectDefConstraint(Berries4ID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(Berries4ID, avoidNatives);
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.44, 0.51);
		
		int Tree3ID = rmCreateObjectDef("random Trees 3");
	    rmAddObjectDefItem(Tree3ID, "TreeNewEngland", rmRandInt(12,18), 6.0);
	    rmSetObjectDefMinDistance(Tree3ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree3ID, 0.0);
	    rmAddObjectDefConstraint(Tree3ID, avoidTrees);
		rmAddObjectDefConstraint(Tree3ID, treesAvoidTrees);
		rmAddObjectDefConstraint(Tree3ID, avoidNatives);
		rmPlaceObjectDefAtLoc(Tree3ID, 0, 0.49, 0.45);
		
		int Berries11ID = rmCreateObjectDef("random Berries 11");
	    rmAddObjectDefItem(Berries11ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries11ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries11ID, 0.0);
	    rmAddObjectDefConstraint(Berries11ID, avoidFruits);
		rmAddObjectDefConstraint(Berries11ID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(Berries11ID, avoidNatives);
		rmPlaceObjectDefAtLoc(Berries11ID, 0, 0.52, 0.44);
		
		int Tree8ID = rmCreateObjectDef("random Trees 8");
	    rmAddObjectDefItem(Tree8ID, "TreeNewEngland", rmRandInt(8,12), 5.0);
		rmSetObjectDefMinDistance(Tree8ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree8ID, 0.0);
	    rmAddObjectDefConstraint(Tree8ID, avoidTrees);
		rmAddObjectDefConstraint(Tree8ID, treesAvoidTrees);
		rmAddObjectDefConstraint(Tree8ID, avoidNatives);
		rmPlaceObjectDefAtLoc(Tree8ID, 0, 0.46, 0.549);
		
		
		rmClearClosestPointConstraints();
/*================================================================================================================*/
// *************************************** STUFFS ON THE RIGHT ISLAND: ****************************************** //		
/*================================================================================================================*/
		int silver4ID = rmCreateObjectDef("random silver 4");
	    rmAddObjectDefItem(silver4ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver4ID, 0.0);
	    rmSetObjectDefMaxDistance(silver4ID, 0.0);
	    rmAddObjectDefConstraint(silver4ID, avoidCoin);
		rmAddObjectDefConstraint(silver4ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver4ID, 0, 0.86, 0.2);
		
		int nugget4= rmCreateObjectDef("nugget easy 4"); 
	    rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nugget4, 0.0);
	    rmSetObjectDefMaxDistance(nugget4, 0.0);
	    rmAddObjectDefConstraint(nugget4, avoidNugget);
  	    rmAddObjectDefConstraint(nugget4, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.78, 0.125);
		
		int nugget10= rmCreateObjectDef("nugget easy 10"); 
	    rmAddObjectDefItem(nugget10, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget10, 0.0);
	    rmSetObjectDefMaxDistance(nugget10, 0.0);
	    rmAddObjectDefConstraint(nugget10, avoidNugget);
  	    rmAddObjectDefConstraint(nugget10, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget10, 0, 0.75, 0.21); // ok
		
		int nugget11= rmCreateObjectDef("nugget easy 11"); 
	    rmAddObjectDefItem(nugget11, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget11, 0.0);
	    rmSetObjectDefMaxDistance(nugget11, 0.0);
	    rmAddObjectDefConstraint(nugget11, avoidNugget);
  	    rmAddObjectDefConstraint(nugget11, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget11, 0, 0.70, 0.16);

        int nugget12= rmCreateObjectDef("nugget easy 12"); 
	    rmAddObjectDefItem(nugget12, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget12, 0.0);
	    rmSetObjectDefMaxDistance(nugget12, 0.0);
	    rmAddObjectDefConstraint(nugget12, avoidNugget);
  	    rmAddObjectDefConstraint(nugget12, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget12, 0, 0.83, 0.25); 		
		
		int Berries3ID = rmCreateObjectDef("random Berries 3");
	    rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(3,5), 6.0);
	    rmSetObjectDefMinDistance(Berries3ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries3ID, 0.0);
	    rmAddObjectDefConstraint(Berries3ID, avoidFruits);
		rmAddObjectDefConstraint(Berries3ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.7, 0.226);
		
		int Berries9ID = rmCreateObjectDef("random Berries 9");
	    rmAddObjectDefItem(Berries9ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries9ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries9ID, 0.0);
	    rmAddObjectDefConstraint(Berries9ID, avoidFruits);
		rmAddObjectDefConstraint(Berries9ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries9ID, 0, 0.810, 0.23);
		
		int Berries10ID = rmCreateObjectDef("random Berries 10");
	    rmAddObjectDefItem(Berries10ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries10ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries10ID, 0.0);
	    rmAddObjectDefConstraint(Berries10ID, avoidFruits);
		rmAddObjectDefConstraint(Berries10ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries10ID, 0, 0.70, 0.125);
		
		int Tree2ID = rmCreateObjectDef("random Trees 2");
	    rmAddObjectDefItem(Tree2ID, "TreeNewEngland", rmRandInt(5,9), 6.0);
	    rmSetObjectDefMinDistance(Tree2ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree2ID, 0.0);
	    rmAddObjectDefConstraint(Tree2ID, avoidTrees);
		rmAddObjectDefConstraint(Tree2ID, treesAvoidTrees);
		rmPlaceObjectDefAtLoc(Tree2ID, 0, 0.77, 0.26);
		
		int Tree5ID = rmCreateObjectDef("random Trees 5");
	    rmAddObjectDefItem(Tree5ID, "TreeNewEngland", rmRandInt(10,12), 6.0);
	    rmSetObjectDefMinDistance(Tree5ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree5ID, 0.0);
	    rmAddObjectDefConstraint(Tree5ID, avoidTrees);
		rmAddObjectDefConstraint(Tree5ID, treesAvoidTrees);
		rmPlaceObjectDefAtLoc(Tree5ID, 0, 0.74, 0.11);
		
		int Tree7ID = rmCreateObjectDef("random Trees 7");
	    rmAddObjectDefItem(Tree7ID, "TreeNewEngland", rmRandInt(8,12), 6.0);
		rmSetObjectDefMinDistance(Tree7ID, 0.0);
	    rmSetObjectDefMaxDistance(Tree7ID, 0.0);
	    rmAddObjectDefConstraint(Tree7ID, avoidTrees);
		rmAddObjectDefConstraint(Tree7ID, treesAvoidTrees);
		rmPlaceObjectDefAtLoc(Tree7ID, 0, 0.735, 0.18);
		
		rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRYBUSH: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/        
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE DEER: ****************************************** // 	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FISH MAHI: ******************************************* //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish Mahi");
        //rmAddObjectDefItem(fishID, "FishMahi", 3, 4.0);
		  rmAddObjectDefItem(fishID, "FishCod", 5, 10.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE FISH TARPON: ***************************************** //
/*================================================================================================================*/
        int fish2ID=rmCreateObjectDef("fish Tarpon");
        //rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 4.0);
		  rmAddObjectDefItem(fish2ID, "FishCod", 5, 10.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
/*================================================================================================================*/
// TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE WHALES: ****************************************** //
/*================================================================================================================*/
        int whaleID=rmCreateObjectDef("whale");
        // rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
		   rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE RANDOM TREES 1: ************************************* //
/*================================================================================================================*/
        rmClearClosestPointConstraints(); 

        int randomTree1ID=rmCreateObjectDef("random tree 1");
        rmAddObjectDefItem(randomTree1ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree1ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree1ID, 0.0);
        rmAddObjectDefConstraint(randomTree1ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree1ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree1ID, 0, 0.90, 0.65);
		
		int randomTree2ID=rmCreateObjectDef("random tree 2");
        rmAddObjectDefItem(randomTree2ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, 0.0);
        rmAddObjectDefConstraint(randomTree2ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree2ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.64, 0.935);
		
		int randomTree3ID=rmCreateObjectDef("random tree 3");
        rmAddObjectDefItem(randomTree3ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree3ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree3ID, 0.0);
        rmAddObjectDefConstraint(randomTree3ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree3ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree3ID, 0, 0.75, 0.85);
		
		int randomTree4ID=rmCreateObjectDef("random tree 4");
        rmAddObjectDefItem(randomTree4ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree4ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree4ID, 0.0);
        rmAddObjectDefConstraint(randomTree4ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree4ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree4ID, 0, 0.85, 0.75);
		
		int randomTree5ID=rmCreateObjectDef("random tree 5");
        rmAddObjectDefItem(randomTree5ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree5ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree5ID, 0.0);
        rmAddObjectDefConstraint(randomTree5ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree5ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree5ID, 0, 0.625, 0.8);
		
		int randomTree6ID=rmCreateObjectDef("random tree 6");
        rmAddObjectDefItem(randomTree6ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree6ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree6ID, 0.0);
        rmAddObjectDefConstraint(randomTree6ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree6ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree6ID, 0, 0.8, 0.625);
		
		int randomTree7ID=rmCreateObjectDef("random tree 7");
        rmAddObjectDefItem(randomTree7ID, "TreeNewEngland", rmRandInt(15,20), 7.0);
        rmSetObjectDefMinDistance(randomTree7ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree7ID, 0.0);
        rmAddObjectDefConstraint(randomTree7ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree7ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree7ID, 0, 0.71, 0.71);
		
		
		int silver7ID = rmCreateObjectDef("random silver 7");
	    rmAddObjectDefItem(silver7ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver7ID, 0.0);
	    rmSetObjectDefMaxDistance(silver7ID, 0.0);
	    rmAddObjectDefConstraint(silver7ID, avoidCoin);
		rmAddObjectDefConstraint(silver7ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver7ID, 0, 0.85, 0.65); 
		
		int silver8ID = rmCreateObjectDef("random silver 8");
	    rmAddObjectDefItem(silver8ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver8ID, 0.0);
	    rmSetObjectDefMaxDistance(silver8ID, 0.0);
	    rmAddObjectDefConstraint(silver8ID, avoidCoin);
		rmAddObjectDefConstraint(silver8ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver8ID, 0, 0.65, 0.85); 
		
		int silver9ID = rmCreateObjectDef("random silver 9");
	    rmAddObjectDefItem(silver9ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver9ID, 0.0);
	    rmSetObjectDefMaxDistance(silver9ID, 0.0);
	    rmAddObjectDefConstraint(silver9ID, avoidCoin);
		rmAddObjectDefConstraint(silver9ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver9ID, 0, 0.825, 0.825); 
		
		int Berries12ID = rmCreateObjectDef("random Berries 12");
	    rmAddObjectDefItem(Berries12ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries12ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries12ID, 0.0);
	    rmAddObjectDefConstraint(Berries12ID, avoidFruits);
		rmAddObjectDefConstraint(Berries12ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries12ID, 0, 0.95, 0.65);
		
		int Berries13ID = rmCreateObjectDef("random Berries 13");
	    rmAddObjectDefItem(Berries13ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries13ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries13ID, 0.0);
	    rmAddObjectDefConstraint(Berries13ID, avoidFruits);
		rmAddObjectDefConstraint(Berries13ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries13ID, 0, 0.6, 0.85);
		
		int Berries14ID = rmCreateObjectDef("random Berries 14");
	    rmAddObjectDefItem(Berries14ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries14ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries14ID, 0.0);
	    rmAddObjectDefConstraint(Berries14ID, avoidFruits);
		rmAddObjectDefConstraint(Berries14ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries14ID, 0, 0.79, 0.89);
		
		int Berries15ID = rmCreateObjectDef("random Berries 15");
	    rmAddObjectDefItem(Berries15ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries15ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries15ID, 0.0);
	    rmAddObjectDefConstraint(Berries15ID, avoidFruits);
		rmAddObjectDefConstraint(Berries15ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries15ID, 0, 0.89, 0.79);
		
		int nugget13= rmCreateObjectDef("nugget easy 13"); 
	    rmAddObjectDefItem(nugget13, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget13, 0.0);
	    rmSetObjectDefMaxDistance(nugget13, 0.0);
	    rmAddObjectDefConstraint(nugget13, avoidNugget);
  	    rmAddObjectDefConstraint(nugget13, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget13, 0, 0.6, 0.95); 
		
		int nugget17= rmCreateObjectDef("nugget easy 17"); 
	    rmAddObjectDefItem(nugget17, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget17, 0.0);
	    rmSetObjectDefMaxDistance(nugget17, 0.0);
	    rmAddObjectDefConstraint(nugget17, avoidNugget);
  	    rmAddObjectDefConstraint(nugget17, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget17, 0, 0.95, 0.6); 
		
		int nugget18= rmCreateObjectDef("nugget easy 18"); 
	    rmAddObjectDefItem(nugget18, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget18, 0.0);
	    rmSetObjectDefMaxDistance(nugget18, 0.0);
	    rmAddObjectDefConstraint(nugget18, avoidNugget);
  	    rmAddObjectDefConstraint(nugget18, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget18, 0, 0.625, 0.89);
		
		int nugget19= rmCreateObjectDef("nugget easy 19"); 
	    rmAddObjectDefItem(nugget19, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget19, 0.0);
	    rmSetObjectDefMaxDistance(nugget19, 0.0);
	    rmAddObjectDefConstraint(nugget19, avoidNugget);
  	    rmAddObjectDefConstraint(nugget19, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget19, 0, 0.9, 0.7);
		
		int nugget20= rmCreateObjectDef("nugget easy 20"); 
	    rmAddObjectDefItem(nugget20, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget20, 0.0);
	    rmSetObjectDefMaxDistance(nugget20, 0.0);
	    rmAddObjectDefConstraint(nugget20, avoidNugget);
  	    rmAddObjectDefConstraint(nugget20, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget20, 0, 0.7, 0.85);
		
		int nugget21= rmCreateObjectDef("nugget easy 21"); 
	    rmAddObjectDefItem(nugget21, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget21, 0.0);
	    rmSetObjectDefMaxDistance(nugget21, 0.0);
	    rmAddObjectDefConstraint(nugget21, avoidNugget);
  	    rmAddObjectDefConstraint(nugget21, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget21, 0, 0.85, 0.7);
		
		int nugget28= rmCreateObjectDef("nugget easy 28"); 
	    rmAddObjectDefItem(nugget28, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget28, 0.0);
	    rmSetObjectDefMaxDistance(nugget28, 0.0);
	    rmAddObjectDefConstraint(nugget28, avoidNugget);
  	    rmAddObjectDefConstraint(nugget28, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget28, 0, 0.675, 0.75);
		
		int nugget29= rmCreateObjectDef("nugget easy 29"); 
	    rmAddObjectDefItem(nugget29, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget29, 0.0);
	    rmSetObjectDefMaxDistance(nugget29, 0.0);
	    rmAddObjectDefConstraint(nugget29, avoidNugget);
  	    rmAddObjectDefConstraint(nugget29, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget29, 0, 0.75, 0.675);
		
		int deer1ID=rmCreateObjectDef("deer herd 1");
	    rmAddObjectDefItem(deer1ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmAddObjectDefConstraint(deer1ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer1ID, true);
        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.6, 0.9);
		
		int deer2ID=rmCreateObjectDef("deer herd 2");
	    rmAddObjectDefItem(deer2ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmAddObjectDefConstraint(deer2ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer2ID, true);
        rmPlaceObjectDefAtLoc(deer2ID, 0, 0.9, 0.6);
		
		int deer3ID=rmCreateObjectDef("deer herd 3");
	    rmAddObjectDefItem(deer3ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer3ID, 0.0);
        rmSetObjectDefMaxDistance(deer3ID, 0.0);
	    rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmAddObjectDefConstraint(deer3ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer3ID, true);
        rmPlaceObjectDefAtLoc(deer3ID, 0, 0.7, 0.8);
		
		int deer4ID=rmCreateObjectDef("deer herd 4");
	    rmAddObjectDefItem(deer4ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer4ID, 0.0);
        rmSetObjectDefMaxDistance(deer4ID, 0.0);
	    rmAddObjectDefConstraint(deer4ID, avoidDeer);
		rmAddObjectDefConstraint(deer4ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer4ID, true);
        rmPlaceObjectDefAtLoc(deer4ID, 0, 0.8, 0.7);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE RANDOM TREES 2: ************************************* //
/*================================================================================================================*/
 		rmClearClosestPointConstraints();
		
		int randomTree8ID=rmCreateObjectDef("random tree 8");
        rmAddObjectDefItem(randomTree8ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree8ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree8ID, 0.0);
        rmAddObjectDefConstraint(randomTree8ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree8ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree8ID, 0, 0.115, 0.25);
		
		int randomTree9ID=rmCreateObjectDef("random tree 9");
        rmAddObjectDefItem(randomTree9ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree9ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree9ID, 0.0);
        rmAddObjectDefConstraint(randomTree9ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree9ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree9ID, 0, 0.25, 0.115);
		
		int randomTree10ID=rmCreateObjectDef("random tree 10");
        rmAddObjectDefItem(randomTree10ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree10ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree10ID, 0.0);
        rmAddObjectDefConstraint(randomTree10ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree10ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree10ID, 0, 0.065, 0.325);
		
		int randomTree11ID=rmCreateObjectDef("random tree 11");
        rmAddObjectDefItem(randomTree11ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree11ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree11ID, 0.0);
        rmAddObjectDefConstraint(randomTree11ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree11ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree11ID, 0, 0.325, 0.065);
		
		int randomTree12ID=rmCreateObjectDef("random tree 12");
        rmAddObjectDefItem(randomTree12ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree12ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree12ID, 0.0);
        rmAddObjectDefConstraint(randomTree12ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree12ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree12ID, 0, 0.375, 0.15);
		
		int randomTree13ID=rmCreateObjectDef("random tree 13");
        rmAddObjectDefItem(randomTree13ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree13ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree13ID, 0.0);
        rmAddObjectDefConstraint(randomTree13ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree13ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree13ID, 0, 0.15, 0.375);
		
		int randomTree14ID=rmCreateObjectDef("random tree 14");
        rmAddObjectDefItem(randomTree14ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree14ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree14ID, 0.0);
        rmAddObjectDefConstraint(randomTree14ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree14ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree14ID, 0, 0.325, 0.225);
		
		int randomTree15ID=rmCreateObjectDef("random tree 15");
        rmAddObjectDefItem(randomTree15ID, "TreeNewEngland", rmRandInt(15,20), 8.0);
        rmSetObjectDefMinDistance(randomTree15ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree15ID, 0.0);
        rmAddObjectDefConstraint(randomTree15ID, avoidTrees);
        rmAddObjectDefConstraint(randomTree15ID, treesAvoidTrees);
        rmPlaceObjectDefAtLoc(randomTree15ID, 0, 0.225, 0.325);
		
		int silver10ID = rmCreateObjectDef("random silver 10");
	    rmAddObjectDefItem(silver10ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver10ID, 0.0);
	    rmSetObjectDefMaxDistance(silver10ID, 0.0);
	    rmAddObjectDefConstraint(silver10ID, avoidCoin);
		rmAddObjectDefConstraint(silver10ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver10ID, 0, 0.115, 0.325);
		
		int silver11ID = rmCreateObjectDef("random silver 11");
	    rmAddObjectDefItem(silver11ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver11ID, 0.0);
	    rmSetObjectDefMaxDistance(silver11ID, 0.0);
	    rmAddObjectDefConstraint(silver11ID, avoidCoin);
		rmAddObjectDefConstraint(silver11ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver11ID, 0, 0.325, 0.115);
		
		int silver12ID = rmCreateObjectDef("random silver 12");
	    rmAddObjectDefItem(silver12ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver12ID, 0.0);
	    rmSetObjectDefMaxDistance(silver12ID, 0.0);
	    rmAddObjectDefConstraint(silver12ID, avoidCoin);
		rmAddObjectDefConstraint(silver12ID, coinAvoidCoin);
		rmPlaceObjectDefAtLoc(silver12ID, 0, 0.165, 0.165);
		
		int nugget22= rmCreateObjectDef("nugget easy 22"); 
	    rmAddObjectDefItem(nugget22, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget22, 0.0);
	    rmSetObjectDefMaxDistance(nugget22, 0.0);
	    rmAddObjectDefConstraint(nugget22, avoidNugget);
  	    rmAddObjectDefConstraint(nugget22, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget22, 0, 0.175, 0.255);
		
		int nugget23= rmCreateObjectDef("nugget easy 23"); 
	    rmAddObjectDefItem(nugget23, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget23, 0.0);
	    rmSetObjectDefMaxDistance(nugget23, 0.0);
	    rmAddObjectDefConstraint(nugget23, avoidNugget);
  	    rmAddObjectDefConstraint(nugget23, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget23, 0, 0.275, 0.275);
		
		int nugget24= rmCreateObjectDef("nugget easy 24"); 
	    rmAddObjectDefItem(nugget24, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget24, 0.0);
	    rmSetObjectDefMaxDistance(nugget24, 0.0);
	    rmAddObjectDefConstraint(nugget24, avoidNugget);
  	    rmAddObjectDefConstraint(nugget24, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget24, 0, 0.375, 0.2);
		
		int nugget25= rmCreateObjectDef("nugget easy 25"); 
	    rmAddObjectDefItem(nugget25, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget25, 0.0);
	    rmSetObjectDefMaxDistance(nugget25, 0.0);
	    rmAddObjectDefConstraint(nugget25, avoidNugget);
  	    rmAddObjectDefConstraint(nugget25, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget25, 0, 0.2, 0.375);
		
		int nugget26= rmCreateObjectDef("nugget easy 26"); 
	    rmAddObjectDefItem(nugget26, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget26, 0.0);
	    rmSetObjectDefMaxDistance(nugget26, 0.0);
	    rmAddObjectDefConstraint(nugget26, avoidNugget);
  	    rmAddObjectDefConstraint(nugget26, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget26, 0, 0.085, 0.275);
		
		int nugget27= rmCreateObjectDef("nugget easy 27"); 
	    rmAddObjectDefItem(nugget27, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget27, 0.0);
	    rmSetObjectDefMaxDistance(nugget27, 0.0);
	    rmAddObjectDefConstraint(nugget27, avoidNugget);
  	    rmAddObjectDefConstraint(nugget27, nuggetAvoidNugget);
		rmPlaceObjectDefAtLoc(nugget27, 0, 0.275, 0.085);
		
		int Berries16ID = rmCreateObjectDef("random Berries 16");
	    rmAddObjectDefItem(Berries16ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries16ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries16ID, 0.0);
	    rmAddObjectDefConstraint(Berries16ID, avoidFruits);
		rmAddObjectDefConstraint(Berries16ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries16ID, 0, 0.2, 0.15);
		
		int Berries17ID = rmCreateObjectDef("random Berries 17");
	    rmAddObjectDefItem(Berries17ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries17ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries17ID, 0.0);
	    rmAddObjectDefConstraint(Berries17ID, avoidFruits);
		rmAddObjectDefConstraint(Berries17ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries17ID, 0, 0.15, 0.2);
		
		int Berries18ID = rmCreateObjectDef("random Berries 18");
	    rmAddObjectDefItem(Berries18ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries18ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries18ID, 0.0);
	    rmAddObjectDefConstraint(Berries18ID, avoidFruits);
		rmAddObjectDefConstraint(Berries18ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries18ID, 0, 0.25, 0.3);
		
		int Berries19ID = rmCreateObjectDef("random Berries 19");
	    rmAddObjectDefItem(Berries19ID, "berrybush", rmRandInt(3,5), 3.5);
	    rmSetObjectDefMinDistance(Berries19ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries19ID, 0.0);
	    rmAddObjectDefConstraint(Berries19ID, avoidFruits);
		rmAddObjectDefConstraint(Berries19ID, fruitsAvoidFruits);
		rmPlaceObjectDefAtLoc(Berries19ID, 0, 0.30, 0.25);
		
		int deer5ID=rmCreateObjectDef("deer herd 5");
	    rmAddObjectDefItem(deer5ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer5ID, 0.0);
        rmSetObjectDefMaxDistance(deer5ID, 0.0);
	    rmAddObjectDefConstraint(deer5ID, avoidDeer);
		rmAddObjectDefConstraint(deer5ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer5ID, true);
        rmPlaceObjectDefAtLoc(deer5ID, 0, 0.15, 0.3);
		
		int deer6ID=rmCreateObjectDef("deer herd 6");
	    rmAddObjectDefItem(deer6ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer6ID, 0.0);
        rmSetObjectDefMaxDistance(deer6ID, 0.0);
	    rmAddObjectDefConstraint(deer6ID, avoidDeer);
		rmAddObjectDefConstraint(deer6ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer6ID, true);
        rmPlaceObjectDefAtLoc(deer6ID, 0, 0.3, 0.15);
		
		int deer7ID=rmCreateObjectDef("deer herd 7");
	    rmAddObjectDefItem(deer7ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer7ID, 0.0);
        rmSetObjectDefMaxDistance(deer7ID, 0.0);
	    rmAddObjectDefConstraint(deer7ID, avoidDeer);
		rmAddObjectDefConstraint(deer7ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer7ID, true);
        rmPlaceObjectDefAtLoc(deer7ID, 0, 0.05, 0.375);
		
		int deer8ID=rmCreateObjectDef("deer herd 8");
	    rmAddObjectDefItem(deer8ID, "deer", rmRandInt(4,6), 6.0);
        rmSetObjectDefMinDistance(deer8ID, 0.0);
        rmSetObjectDefMaxDistance(deer8ID, 0.0);
	    rmAddObjectDefConstraint(deer8ID, avoidDeer);
		rmAddObjectDefConstraint(deer8ID, deerAvoidDeer);
        rmSetObjectDefCreateHerd(deer8ID, true);
        rmPlaceObjectDefAtLoc(deer8ID, 0, 0.375, 0.05);
		
		
/*================================================================================================================*/
// ************************ EXTRA TREE CLUMPS NEAR PLAYERS - TO ENSURE FAIR ACCESS TO WOOD: ********************* //
/*================================================================================================================*/
/*        //                      rmCreateObjectDef(string name); 
		// ex: int extraTreesID=rmCreateObjectDef("extra trees");
		       int extraTreesID=rmCreateObjectDef("extra trees");
        
		//     rmAddObjectDefItem(int defID, string unitName, int count, float cluster distance); 
		// ex: rmAddObjectDefItem(extraTreesID, "TreeAmazon", 5, 5.0);
		       rmAddObjectDefItem(extraTreesID, "TreeAmazon", 5, 5.0);
		
		//     rmSetObjectDefMinDistance(int defID, float dist);
		// ex: rmSetObjectDefMinDistance(extraTreesID, 14);
		       rmSetObjectDefMinDistance(extraTreesID, 14);
        
		//     rmSetObjectDefMaxDistance(int defID, float dist);
		// ex: rmSetObjectDefMaxDistance(extraTreesID, 18);
		       rmSetObjectDefMaxDistance(extraTreesID, 18);
        
		//bool rmAddObjectDefConstraint(int defID, int constraintID);
		// ex: rmAddObjectDefConstraint(extraTreesID, avoidAll);
		       rmAddObjectDefConstraint(extraTreesID, avoidAll);
		
		rmAddObjectDefConstraint(extraTreesID, avoidWood);
		rmAddObjectDefConstraint(extraTreesID, woodAvoidWood);
		rmAddObjectDefConstraint(extraTreesID, avoidTC);
        rmAddObjectDefConstraint(extraTreesID, avoidCoin);
		rmAddObjectDefConstraint(extraTreesID, avoidFruits);
        rmAddObjectDefConstraint(extraTreesID, avoidImpassableLand);
        rmAddObjectDefConstraint(extraTreesID, playerEdgeConstraint);
			    
        for(i=1; <cNumberPlayers)
        
		//rmPlaceObjectDefInArea(extraTreesID, 0, rmAreaID("Player"+i), 2); // NOT WORKING...
		
		//     rmPlaceObjectDefAtAreaLoc(int defID, int playerID, int areaID, long placeCount);
		// ex: rmPlaceObjectDefAtAreaLoc(extraTreesID, 0, rmAreaID("Player"+i), 3);
		       rmPlaceObjectDefAtAreaLoc(extraTreesID, 0, rmAreaID("Player"+i), 3);*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*================================================================================================================*/
// ************************************ THIS IS THE END OF THE MAP: ********************************************* //
/*================================================================================================================*/    

